<?php

/**
 * ca_cesion_excedentes actions.
 *
 * @package    cartera
 * @subpackage ca_cesion_excedentes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ca_cesion_excedentesActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_CESION_EXCEDENTES_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_CESION_EXCEDENTES_V' =>
        array(
            'id_cesion_excedentes' => 'id_cesion_excedentes',
            'id_excedente' => 'id_excedente',
            'fecha_proceso' => 'fecha_proceso',
            'usuariolog' => 'usuariolog',
            'fecha_log' => 'fecha_log',
            'valor' => 'valor',
            'num_doc' => 'num_doc',
            'id_ts_td' => 'id_ts_td',
            'fecha_doc' => 'fecha_doc',
            'id_mae_ter_ant' => 'id_mae_ter_ant',
            'id_mae_ter' => 'id_mae_ter',
            'observaciones' => 'observaciones',
            'sec_credito' => 'sec_credito',
            'fecha_credito' => 'fecha_credito',
            'num_doc_ant' => 'num_doc_ant',
            'razon_soc_ant' => 'razon_soc_ant',
            'num_doc_nuevo' => 'num_doc_nuevo',
            'razon_soc_nuevo' => 'razon_soc_nuevo',
            'tipo_doc' => 'tipo_doc'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_CESION_EXCEDENTES_V' => array(
            'id_cesion_excedentes,a' => array('!=' => array(-1)),
            'id_cesion_excedentes,b' => array('=' => array('id_cesion_excedentes')),
            'id_excedente' => array('=' => array('id_excedente')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //eliminar filas repetivas de consulta sql
    protected $fields_orderBy = array(
        'id_excedente'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /**
     * Metodo para add debito ref 
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
        $fecha_proceso = CN_TABLE::fechaSistema();

        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables obligatorias
             */
            $id_excedente = $request['id_excedente'];
            $id_mae_ter = $request['id_mae_ter'];
            $id_mae_ter_ant = $request['id_mae_ter_ant'];
            $id_ts_td = $request['id_ts_td'];
            //$fecha_proceso = $request['fecha_proceso'];
            $fecha_doc = $request['fecha_doc'];
            $num_doc = $request['num_doc'];
            $observaciones = $request['observaciones'];

            //SACAR EL SALDO
            //sentencia sql
            $sql = <<<EOD
SELECT * FROM CA_EXCEDENTES
WHERE id_excedente = $id_excedente 
EOD;

            //ejecuta el sql
            $result = CN_TABLE::executeSQL($sql);
            $valor = 0;

            if ($result[0]['valor'] != "") {
                $valor = $result[0]['valor'];
            }

            //el username desde qebsafiERP
            $usuario = 'admin';
            if (isset($request['username']) && $request['username'] != '') {
                $usuario = $request['username'];
            }



            //sentencia sql ingresar CA_DEBITO
            $sql = <<<EOD
insert into CA_CESION_EXCEDENTES (id_cesion_excedentes,id_excedente,
    fecha_proceso,usuariolog,fecha_log,valor,num_doc,id_ts_td,fecha_doc,id_mae_ter_ant,
    id_mae_ter,observaciones) 
    values (null,$id_excedente,sysdate,'$usuario'
        ,sysdate,
        $valor,$num_doc,$id_ts_td,to_date('$fecha_doc','yyyy-mm-dd'), $id_mae_ter_ant, $id_mae_ter,'$observaciones')
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            //SE ACTUALIZA EL TERCERO EN LA TABLA DE DEBITO

            $sql = <<<EOD
update CA_EXCEDENTES set 
id_mae_ter = $id_mae_ter
where id_excedente = $id_excedente 
EOD;

//ejecuta el sql
            CN_TABLE::executeSQL($sql);

            $this->list_data = array();
            
            
            /**
             * Llamado INTERFAZ CONTABLE - 20171103
             */
            $this->logMessage("INICIO INTERFAZ CONTABLE CESION EXCEDENTES");

            //Se trae de la configuracion la url que se ha establecido para las interfaces contables
            $arrayAtrib = array();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                if ('service_url' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        if ($key == 'value') {
                            $service_url = $value;
                        }
                    }
                }
                $int++;
            }
            $url = $service_url;
            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
            //variables del debito
            //$fecha_proceso = $fecha_sistema;
            $id_mae_ter = 946;
            $mov_ejecutado = "Excedentes-.-Cartera";
            $url = $url . '&fecha_proceso=' . $fecha_proceso;
            $url = $url . '&id_mae_ter=' . $id_mae_ter;
            $url = $url . '&mov_ejecutado=' . $mov_ejecutado;
            //$url = $url . '&id_movimiento=' . $id_cesion_excedentes;
            $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json

            $ch = curl_init($url);

            //Parametros de retorno en cURL
            curl_setopt($ch, CURLOPT_HEADER, 0);
            $rta = curl_exec($ch);
            curl_close($ch);

            $arrayRespuesta = json_decode($rta, true);
            //Verifica el status, si es diferente de 0, ocurrio un error al subir la interfaz y debe reportarlo
            if ($arrayRespuesta['response']['status'] == 1) {
                $mensajeError = "Error :: Al generar la interfaz contable.";
                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[ca_cesion_cartera] " . $mensajeError);
            } else {
                $this->logMessage("[ca_cesion_cartera] Genero interfaz contable.");
            }

            $this->logMessage("FIN INTERFAZ CONTABLE CESION EXCEDENTES");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
